--Test Project for the clockBuffer
--which uses a PLL from the Megawizard in Quartus
--4/13/11

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity Neuron_Project is
	port(
		KEY: in std_logic_vector(3 downto 0);
		CLOCK_50: in std_logic;
		LEDG: out std_logic_vector (7 downto 0)
	);
end Neuron_Project;

architecture testbench of Neuron_Project is

	signal clock50MHz: std_logic;
	signal reset: std_logic;

	component clockBuffer IS
		PORT
		(
			areset		: IN STD_LOGIC  := '0';
			inclk0		: IN STD_LOGIC  := '0';
			c0		: OUT STD_LOGIC 
		);
	END component;
	
begin

	--keys are active low
	reset <= not KEY(0);
	
	clockBufferInstance: clockBuffer port map(reset,CLOCK_50,clock50MHz);
	
	LEDG(7) <= clock50MHz;

end testbench;