--5/17/11
--Multiplies two 18-bit signed numbers,
--returns the 18 most significant bits

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;


entity signedMultiplier is
	port(
		multiplier: in std_logic_vector(17 downto 0);
		multiplicand: in std_logic_vector(17 downto 0);
		product: out std_logic_vector(17 downto 0)
	);
end signedMultiplier;

architecture behavior of signedMultiplier is

	signal product_vector: std_logic_vector(35 downto 0);

begin

	product_vector <= multiplier * multiplicand;
	--sign bit is bit 35.  The bottom 32 bits are the least significant decimal bits and are ignored.  Bits 34 and 33 are the overflow bits
	product <= product_vector(35) & product_vector(32 downto 16);

end behavior;