--5/3/11
--Modelsim Test Bench for the Rom controller

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity ROMcontrollerTB is
end ROMcontrollerTB;

architecture testbench of ROMcontrollerTB is

	--Modelsim signals
	signal CLOCK_50K, CLOCK_50M: std_logic := '1'; --have to initialize the clock, or modelsim cries
	signal reset_Sig: std_logic;
	signal increment_Sig: std_logic;
	signal ROMword_Sig: std_logic_vector(23 downto 0);

	component ROMcontroller is 
		port(
			--asynch active-high reset
			reset: in std_logic;
			increment: in std_logic;
			clock50KHz: in std_logic;
			clock50MHz: in std_logic;
			ROMword: out std_logic_vector(23 downto 0)
		);
	end component;

begin

	ROMcontrollerInstance: ROMcontroller port map(reset_Sig, increment_Sig, CLOCK_50K, CLOCK_50M, ROMword_Sig);
	
	--clock 50MHz stimulus
	process
	begin
		wait for 10 ns;
		CLOCK_50M <= not CLOCK_50M;
	end process;
	
	--clock 50KHz stimulus
	process
	begin
		wait for 100 ns;
		CLOCK_50K <= not CLOCK_50K;
	end process;
	
	--signal stimulus
	process	
	begin
		--initially in reset
		reset_Sig <= '1';
		increment_Sig <= '0';
		
		wait for 20 ns;
		
		reset_Sig <= '0';
		
		wait for 180 ns;
		
		increment_Sig <= '1';
		
		wait for 200 ns;
		
		increment_sig <= '0';
		
		wait for 1000 ns;
		
		increment_sig <= '1';
		
		--wait forever
		wait;
	end process;

end testbench;