LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity clockBufferTB is
end clockBufferTB;

architecture testbench of clockBufferTB is

	--simulated ports
	signal KEY: std_logic_vector(3 downto 0);
	--CLOCK_50 is the DE1 signal, clock50MHz is the output of 
	--the clockBuffer PLL component
	signal CLOCK_50,clock50MHz: std_logic := '1';
	
	--internal signals
	signal reset: std_logic;

	component clockBuffer IS
		PORT
		(
			areset		: IN STD_LOGIC  := '0';
			inclk0		: IN STD_LOGIC  := '0';
			c0		: OUT STD_LOGIC 
		);
	END component;
	
begin

	--keys are active low
	reset <= not KEY(0);
	
	clockBufferInstance: clockBuffer port map(reset,CLOCK_50,clock50MHz);
	
	--simulate 50MHz clock signal
	clock: process
	begin
		wait for 10 ns;
			CLOCK_50 <= not CLOCK_50;
	end process;
	
	--stimulus
	stimulus: process
	begin
		--start condition - in reset initially
		KEY(0) <= '0';
		wait for 20 ns; 
	
		--disable reset
		KEY(0) <= '1';

		--wait forever
		wait;
	end process;

end testbench;