--5/2/11
--Test Bench for Modelsim
--synchronous counter using the 50khz clock from the audioCodecController
--counts the dataBits (0 to 23) sent to the audio codec

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity dataBitCounterTB is
end dataBitCounterTB;

architecture testbench of dataBitCounterTB is 

	--simulation signals
	signal clock: std_logic := '1'; 
	signal enable: std_logic := '0';
	signal reset: std_logic := '1';
	signal countBits: integer;
	signal countWords: integer;

	component dataBitCounter is
		port(
			--active high count enable
			countEnable: in std_logic;
			--active high reset
			reset: in std_logic;
			clock: in std_logic;
			currentBitCount: out integer;
			currentWordCount: out integer
		);
	end component;

begin

	dataBitCounterInstance: dataBitCounter port map(enable, reset, clock, countBits, countWords);
	
	--simulation stimulus
	process
	begin
		--wait 1/2 clock cycle (50MHz clock)
		wait for 10 ns;
		clock <= not clock;
	end process;

	--stimulus
	process
	begin
		--start condition - in reset initially
		reset <= '1';
		enable <= '0';
		
		wait for 20 ns;
	
		reset <= '0';
		
		wait for 20 ns; 

		enable <= '1';

		--wait forever
		wait;
	end process;	

end testbench;