--5/17/11
--Modelsim test bench for 18-bit vector signed multiplier

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity signedMultiplierTB is
end signedMultiplierTB;

architecture testbench of signedMultiplierTB is

	--Modelsim signal
	signal multiplier_port: std_logic_vector(17 downto 0) := '0'&'0'&X"0000";
	signal multiplicand_port: std_logic_vector(17 downto 0) := '0'&'0'&X"0000";
	signal product_port: std_logic_vector(17 downto 0);

	component signedMultiplier is
		port(
			multiplier: in std_logic_vector(17 downto 0);
			multiplicand: in std_logic_vector(17 downto 0);
			product: out std_logic_vector(17 downto 0)
		);
	end component;
	
begin

	signedMultiplierMap: signedMultiplier port map (multiplier_port, multiplicand_port, product_port);
	
	--stimulus 
	process
	begin
		wait for 20 ns;
		multiplier_port <= '0'&'0'&X"4000";
		multiplicand_port <= '0'&'0'&X"4000";
		wait;
	end process;

end testbench;
